#!/bin/sh

source /koolshare/scripts/base.sh
alias echo_date='echo 【$(TZ=UTC-8 date -R +%Y年%m月%d日\ %X)】:'
module=verysync
DIR=$(cd $(dirname $0); pwd)
ROG_86U=0
EXT_NU=$(nvram get extendno)
EXT_NU=${EXT_NU%_*}
odmpid=$(nvram get odmpid)
productid=$(nvram get productid)
[ -n "${odmpid}" ] && MODEL="${odmpid}" || MODEL="${productid}"
LINUX_VER=$(uname -r|awk -F"." '{print $1$2}')

# 获取固件类型
_get_type() {
  local FWTYPE=$(nvram get extendno|grep koolshare)
  if [ -d "/koolshare" ];then
    if [ -n $FWTYPE ];then
      echo "koolshare官改固件"
    else
      echo "koolshare梅林改版固件"
    fi
  else
    if [ "$(uname -o|grep Merlin)" ];then
      echo "梅林原版固件"
    else
      echo "华硕官方固件"
    fi
  fi
}

exit_install(){
  local state=$1
  case $state in
    1)
      echo_date "本插件适用于【koolshare 梅林改/官改 hnd/axhnd/axhnd.675x armsoft 384】固件平台！"
      echo_date "你的固件平台不能安装！！!"
      echo_date "如有问题请联系我们反馈相关信息 http://forum.verysync.com"
      echo_date "退出安装！"
      rm -rf /tmp/${module}* >/dev/null 2>&1
      exit 1
      ;;
    0|*)
      rm -rf /tmp/${module}* >/dev/null 2>&1
      exit 0
      ;;
  esac
}

if [ "`uname -o|grep Merlin`" ] && [ -d "/koolshare" ] && [ -n "`nvram get buildno|grep 384`" ];then
  echo_date 固件平台【koolshare merlin armv7l 384】符合安装要求，开始安装插件！
elif [ -d "/koolshare" -a -f "/usr/bin/skipd" -a "${LINUX_VER}" -ge "41" ];then
  # 判断路由架构和平台：koolshare固件，并且linux版本大于等于4.1
  echo_date 机型：${MODEL} $(_get_type) 符合安装要求，开始安装插件！
else
  exit_install 1
fi

# stop ssserver first
enable=`dbus get verysync_enable`
if [ "$enable" == "1" ];then
  sh /koolshare/scripts/verysync_config.sh stop
fi


# cp -rf /tmp/verysync/bin/* /koolshare/bin/
cp -rf /tmp/verysync/scripts/* /koolshare/scripts/
cp -rf /tmp/verysync/webs/* /koolshare/webs/
cp -rf /tmp/verysync/res/* /koolshare/res/
cp -rf /tmp/verysync/init.d/* /koolshare/init.d/

# chmod +x /koolshare/bin/verysync
chmod +x /koolshare/scripts/*
chmod +x /koolshare/init.d/*

# add icon into softerware center
# dbus set verysync_version=`/koolshare/bin/verysync -version|awk '{print $2}'`
dbus set softcenter_module_verysync_install="1"
dbus set softcenter_module_verysync_version="$(cat $DIR/version)"
dbus set softcenter_module_verysync_name="verysync"
dbus set softcenter_module_verysync_title="微力同步"
dbus set softcenter_module_verysync_description="自己的私有云"



dbus set verysync_disklist=`df -h $1  | grep mnt| awk '
    BEGIN { ORS = ""; print " [ "}
    /Filesystem/ {next}
    { printf "%s{\"name\": \"%s\", \"size\": \"%s\", \"usage\": \"%s\", \"free\": \"%s\", \"mount_point\": \"%s\"}",
          separator, $1, $2, $3, $4, $6
      separator = ", "
    }
    END { print " ] " }
'|openssl base64`

rm -rf /tmp/verysync* >/dev/null 2>&1
# 完成
echo_date "verysync 插件安装完毕！"
exit_install
